# Invisibility Plugin

This unofficial TaleSpire plugin is for a PC version of Hide. The core TS Hide function
allows the GM to see the hidden mini but not the owner. This is not ideal for functions
like stealth where the player should be able to see the mini and still be able to move
the mini. This plugin adds a PC version of Hide which cause the mini, when hidden, to be
visible to the owner and GM but not other players.

When in PC Hide mode the player's base changes texture to indicate to the player that the
mini is in PC Hide mode. The original base texture is restored when the mini in revealed. 
 
## Change Log
```
1.2.0: Updated for compatability with BR Slab Browser update
1.1.0: Migrated to Asset Data Plugin (instead of Stat Messaging Plugin)
1.0.2: Fixed compatability with latest RadialUI version
1.0.1: PC Hide option is only available on owned minis (all minis for GM)
1.0.1: PC Hide states are restored on board re-load
1.0.1: PC Hide states are restored on board load. Uses brute force approach.
1.0.0: Initial release
```
## Install

Install using R2ModMan.

## Usage

Right click a mini to open the radial menu. The new menu should include the new PC Hide option 
(looks like two eyes on top of each other with one crossed out). Click on the PC Hide icon
to toggle the hide status. When hidden, the GM and owner will be able to see the mini (with a
differently textures base to make it obvious that it is in PC Hide mode) and other players will
note be able to see the mini. When the PC Hide option is selected again, it will Reveal the
mini making it visible to all (and restoring the original base texture).

### Original Hide Function

By default the original Hide option (sometimes referred to as the GM Hide option) is still
available in the root of the character menu (as always). However, some players who won't use
the original Hide option frequently anymore (because they will use the PC Hide instead) can
go into their R2ModMan configuration for the plugin where they will find a setting that allows
the original Hide menu to me moved into the GM menu so it does not take up space in the root
character menu. This is a client side setting and each user of the plugin can have a differently
setting without breaking compatibility.

## Limitations

1. To require the least amount of processing power (i.e. no code in the Update loop) the plugin
   only recalculates changes to visibility when the PC Hide function is toggled. This means that
   if the GM changes or a player's ownership of the plugin changes, the visibility will not be
   reflected immediately. There are two possible work around. The first is to use the Invisibility
   Refresh keyboard shortcut (default RCTRL+I). This will refresh the visibility states of all
   PC hidden minis respecting the new GM and/or ownership. The alternate method is to toggle the
   PC hide state to off and then back to on again. Either option works.
   
2. Line of Sight Visibility has not been tested with this plugin because I need to test that
   with other players. If you try this plugin with multiple players, let me know what happens
   to LoS visibility. I'm am guessing that it will work as always with the hidden PC still
   contributing towards the view of other players (i.e. other players will be able to see what
   the hidden player sees). If this is the case, there is not much I can do about that without
   crippling the hidden player's own sight. However, it is also possible that while hidden the
   player's mini may not trigger LoS visibility in which case the plugin may become somewhat
   useless because it would also prevent the hidden character from seeing foes.

3. This plugin changes the base when a mini is PC hidden so that a player is notified when he
   or she is not visible to other players. This means that the plugin is "incompatible" with
   other plugins that affect the base such as the GlowPlugin. The two plugins can still run
   together but most likely GlowPlugin will overwrite Invisibility plugins base re-texturing
   so it will no longer be obvious to the player if he/she is PC hidden or not.   